# Unit conversion

## Unit conversion functions

wreport has its own domain-specific unit conversion functions, working with unit names from BUFR/CREX B tables.

double wreport::convert_units(const char *from, const char *to, double val)

  Convert between different units.

  Parameters:

    - from – Unit of the value to convert (see wreport::Varinfo)

    - to – Unit to convert to (see wreport::Varinfo)

    - val – Value to convert

  Return values:

    res – Converted value

  Returns:

    The error indicator for the function (See error.h)

double wreport::convert_icao_to_press(double from)

  Convert ICAO height (in meters) to pressure (in hpa) and back.

double wreport::convert_press_to_icao(double from)

  Convert pressure (in hpa) to ICAO height (in meters).

double wreport::convert_octants_to_degrees(int from)

  Convert wind direction (in octants) to degrees.

int wreport::convert_degrees_to_octants(double from)

  Convert wind direction (in degrees) to octancts.

unsigned wreport::convert_AOFVSS_to_BUFR08042(unsigned from)

  Convert vertical sounding significance from the AOF encoding to BUFR code table 08001.

int wreport::convert_WMO0500_to_BUFR20012(int from)

  Conversion functions between various code tables.

  Cloud type

int wreport::convert_WMO0509_to_BUFR20012(int from)

  Cloud type (CH).

int wreport::convert_WMO0515_to_BUFR20012(int from)

  Cloud type (CM).

int wreport::convert_WMO0513_to_BUFR20012(int from)

  Cloud type (CL).

int wreport::convert_WMO4677_to_BUFR20003(int from)

  Present weather.

int wreport::convert_WMO4561_to_BUFR20004(int from)

  Past weather.

int wreport::convert_BUFR20012_to_WMO0500(int from)

  Cloud type.

int wreport::convert_BUFR20012_to_WMO0509(int from)

  Cloud type (CH).

int wreport::convert_BUFR20012_to_WMO0515(int from)

  Cloud type (CM).

int wreport::convert_BUFR20012_to_WMO0513(int from)

  Cloud type (CL).

int wreport::convert_BUFR20003_to_WMO4677(int from)

  Present weather.

int wreport::convert_BUFR20004_to_WMO4561(int from)

  Past weather.

unsigned wreport::convert_BUFR08001_to_BUFR08042(unsigned from)

  Vertical sounding significance.

unsigned wreport::convert_BUFR08042_to_BUFR08001(unsigned from)

  Vertical sounding significance.

double wreport::convert_units_get_mul(const char *from, const char *to)

  Get the multiplier used in the given conversion.

  Parameters:

    - from – Unit of the value to convert (see wreport::Varinfo)

    - to – Unit to convert to (see wreport::Varinfo)

  Returns:

    Multiplier factor used in the conversion

bool wreport::convert_units_allowed(const char *from, const char *to)

  Check if conversion is possible among the given units.

  Parameters:

    - from – Unit of the value to convert (see wreport::Varinfo)

    - to – Unit to convert to (see wreport::Varinfo)

  Returns:

    True if conversion is supported, else false.